'------------------------------------------------------------------------------
' <autogenerated>
'     This code was generated by Measurement Studio.
'     Runtime Version: 1.1.4322.573
'
'     Changes to this file may cause incorrect behavior and will be lost if 
'     the code is regenerated.
' </autogenerated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace InstrumentDriverInterop.Ivi

Public Class niSwitch
    Inherits Object
    Implements System.IDisposable
    
    Private _handle As System.IntPtr
    
    Private _disposed As Boolean = true
    
    '''<summary>
    '''Returns a session handle used to identify the switch module in all subsequent instrument driver calls. 
    '''
    '''niSwitch_init creates a new IVI instrument driver session for the switch module specified in the resource name parameter. If multiple topologies are valid for that device, the driver uses the default topology specified in MAX.
    '''
    '''By default, the switch module is reset to a known state.
    '''
    '''An error is returned if a session to the specified resource exists in another process. The same session is returned if niSwitch_init is called twice in the same process for the same resource with the same topology. 
    '''
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Resource name of the switch module to initialize.
    '''
    '''Default value: None 
    '''
    '''Syntax:
    '''
    '''Optional fields are shown in square brackets ([]).
    '''
    '''Configured in MAX Under         Valid Syntax 
    '''NI-DAQmx Devices                DAQmxDeviceName 
    '''Traditional NI-DAQ Devices      SCXI[chassis ID]::slot number 
    '''PXI System                      PXI[bus number]::device number 
    '''
    '''TIP:  IVI logical names are also valid for the resource name. 
    '''
    '''Default values for optional fields:
    '''
    '''chassis ID = 1
    '''bus number = 0
    '''
    '''Example resource names:
    '''
    '''Resource Name    Description 
    '''SC1Mod3          NI-DAQmx module in chassis "SC1" slot 3 
    '''MySwitch         NI-DAQmx module renamed to "MySwitch" 
    '''SCXI1::3         Traditional NI-DAQ module in chassis 1, slot 3 
    '''SCXI::3          Traditional NI-DAQ module in chassis 1, slot 3 
    '''PXI0::16         PXI bus 0, device number 16 
    '''PXI::16          PXI bus 0, device number 16 
    '''
    '''</param>
    '''<param name="ID_Query">
    '''This parameter is ignored. 
    '''
    '''Because NI-SWITCH supports multiple switch modules, it always queries the switch device to determine which device is installed. For this reason, this VI may return NISWITCH_ERROR_FAIL_ID_QUERY even if this parameter is set to VI_FALSE. 
    '''
    '''Valid Values: 
    '''VI_TRUE  - (Default Value)
    '''VI_FALSE - Currently unsupported.
    '''</param>
    '''<param name="Reset_Device">
    '''Specifies whether to reset the switch module during the initialization process. 
    '''Valid Values: 
    '''VI_TRUE - Reset Device (Default Value) 
    '''VI_FALSE - Currently unsupported. The device will not reset.
    '''</param>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Returns a session handle used to identify the switch module in all subsequent instrument driver calls and optionally sets the initial state of the session. 
    '''
    '''niSwitch_InitWithOptions creates a new IVI instrument driver session for the switch module specified in the resource name parameter. If multiple topologies are valid for that device, the driver uses the default topology specified in MAX. The topology is also configurable in the options string parameter.
    '''
    '''By default, the switch module is reset to a known state.
    '''
    '''Enable simulation in the options string parameter.
    '''
    '''An error is returned if a session to the specified resource exists in another process. The same session is returned if niSwitch_InitWithOptions is called twice in the same process for the same resource with the same topology. 
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Resource name of the switch module to initialize.
    '''
    '''Default value: None 
    '''
    '''Syntax:
    '''
    '''Optional fields are shown in square brackets ([]).
    '''
    '''Configured in MAX Under         Valid Syntax 
    '''NI-DAQmx Devices                DAQmxDeviceName 
    '''Traditional NI-DAQ Devices      SCXI[chassis ID]::slot number 
    '''PXI System                      PXI[bus number]::device number 
    '''
    '''TIP:  IVI logical names are also valid for the resource name. 
    '''
    '''Default values for optional fields:
    '''
    '''chassis ID = 1
    '''bus number = 0
    '''
    '''Example resource names:
    '''
    '''Resource Name    Description 
    '''SC1Mod3          NI-DAQmx module in chassis "SC1" slot 3 
    '''MySwitch         NI-DAQmx module renamed to "MySwitch" 
    '''SCXI1::3         Traditional NI-DAQ module in chassis 1, slot 3 
    '''SCXI::3          Traditional NI-DAQ module in chassis 1, slot 3 
    '''PXI0::16         PXI bus 0, device number 16 
    '''PXI::16          PXI bus 0, device number 16 
    '''</param>
    '''<param name="ID_Query">
    '''This parameter is ignored. 
    '''
    '''Because NI-SWITCH supports multiple switch modules, it always queries the switch device to determine which device is installed. For this reason, this VI may return NISWITCH_ERROR_FAIL_ID_QUERY even if this parameter is set to VI_FALSE. 
    '''
    '''Valid Values: 
    '''VI_TRUE  - (Default Value)
    '''VI_FALSE - Currently unsupported.
    '''</param>
    '''<param name="Reset_Device">
    '''Specifies whether to reset the switch module during the initialization process. 
    '''Valid Values: 
    '''VI_TRUE - Reset Device (Default Value) 
    '''VI_FALSE - Currently unsupported. The device will not reset.
    '''</param>
    '''<param name="Options_String">
    '''Sets initial values of certain attributes for the NI-SWITCH session.
    '''
    '''Default value: Simulate=0,RangeCheck=1,DriverSetup=topology:1127/2-Wire 32x1 Mux 
    '''
    '''The following table lists the attribute string names you can use:
    '''
    '''RangeCheck        1   NISWITCH_ATTR_RANGE_CHECK
    '''QueryInstrStatus  1   NISWITCH_ATTR_QUERY_INSTRUMENT_STATUS
    '''Cache             1   NISWITCH_ATTR_CACHE
    '''Simulate          0   NISWITCH_ATTR_SIMULATE
    '''RecordCoercions   0   NISWITCH_ATTR_RECORD_COERCIONS
    '''DriverSetup topology  1127/2-Wire 32x1 Mux 
    '''
    '''
    '''The format of the option string is, "AttributeStringName=Value" where AttributeStringName is the name of the attribute shown above and Value is the value to which the attribute will be set. To set multiple attributes, separate assignments with a comma. 
    '''
    '''If you pass an empty string for this parameter, the NI-SWITCH session uses the default values for the attributes. You can override the default values by explicitly assigning a value. You do not have to specify all of the available attributes. If you do not specify an attribute, its default value is used. 
    '''
    '''Use the DriverSetup attribute to set the topology or the resource type (DAQmx or Traditional DAQ) of the switch module. This attribute can contain config token/value pairs within it.
    '''
    '''DriverSetup=[config token]:[value];[config token 2]:[value 2]
    '''
    '''Valid Config Tokens and Values:
    '''
    '''
    '''
    '''Token Value 
    '''topology  - Refer to Devices Overview for valid values. Default: MAX configured topology for each device. 
    '''
    '''resourcetype  - "daqmx" for devices configured under NI-DAQmx Devices in MAX or "legacy" for devices configured under Traditional NI-DAQ Devices in MAX. Default: daqmx 
    '''
    '''For example, use the following string to set an NI SCXI-1127 as a 2-wire 32x1 multiplexer configured in MAX under DAQmx Devices: 
    '''
    '''"DriverSetup=topology:1127/2-Wire 32x1 Mux;resourcetype:daqmx"
    '''
    '''The DriverSetup string is particularly important when using NI-SWITCH through the IviSwitch class driver. 
    '''
    '''To enable simulation, set simulate equal to 1 and specify the switch module and topology of the switch module to simulate. The following string enables simulation for an SCXI-1127 configured as a 2-wire 32x1 multiplexer.
    '''
    '''"Simulate=1, DriverSetup=topology:1127/2-Wire 32x1 Mux"
    '''
    '''If simulate is set to 1 and the DriverSetup string specifies a topology, the topology is used to determine which device to simulate. If the DriverSetup string does not specify a topology, the device specified in resource name is simulated. 
    '''</param>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean, ByVal Options_String As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Options_String, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Returns a session handle used to identify the switch module in all subsequent instrument driver calls and sets the topology of the switch module. 
    '''
    '''niSwitch_InitWithTopology creates a new IVI instrument driver session for the switch module specified in the resource name parameter. The driver uses the topology specified in the topology name parameter and overrides the topology specified in MAX.
    '''
    '''By default, the switch module is reset to a known state.
    '''
    '''Enable simulation by specifying the topology and setting the simulate parameter to VI_TRUE. 
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Resource name of the switch module to initialize.
    '''
    '''Default value: None 
    '''
    '''Syntax:
    '''
    '''Optional fields are shown in square brackets ([]).
    '''
    '''Configured in MAX Under         Valid Syntax 
    '''NI-DAQmx Devices                DAQmxDeviceName 
    '''Traditional NI-DAQ Devices      SCXI[chassis ID]::slot number 
    '''PXI System                      PXI[bus number]::device number 
    '''
    '''TIP:  IVI logical names are also valid for the resource name. 
    '''
    '''Default values for optional fields:
    '''
    '''chassis ID = 1
    '''bus number = 0
    '''
    '''Example resource names:
    '''
    '''Resource Name    Description 
    '''SC1Mod3          NI-DAQmx module in chassis "SC1" slot 3 
    '''MySwitch         NI-DAQmx module renamed to "MySwitch" 
    '''SCXI1::3         Traditional NI-DAQ module in chassis 1, slot 3 
    '''SCXI::3          Traditional NI-DAQ module in chassis 1, slot 3 
    '''PXI0::16         PXI bus 0, device number 16 
    '''PXI::16          PXI bus 0, device number 16 
    '''</param>
    '''<param name="Topology">
    '''Pass the topology name you want to use for the switch you specify with Resource Name parameter. 
    '''Default Value: 
    '''NISWITCH_TOPOLOGY_1127_2_WIRE_32X1_MUX 
    '''
    '''Valid Values: 
    '''NISWITCH_TOPOLOGY_1127_1_WIRE_64X1_MUX 
    '''NISWITCH_TOPOLOGY_1127_2_WIRE_32X1_MUX 
    '''NISWITCH_TOPOLOGY_1127_2_WIRE_4X8_MATRIX 
    '''NISWITCH_TOPOLOGY_1127_4_WIRE_16X1_MUX 
    '''NISWITCH_TOPOLOGY_1127_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_1128_1_WIRE_64X1_MUX 
    '''NISWITCH_TOPOLOGY_1128_2_WIRE_32X1_MUX 
    '''NISWITCH_TOPOLOGY_1128_2_WIRE_4X8_MATRIX 
    '''NISWITCH_TOPOLOGY_1128_4_WIRE_16X1_MUX 
    '''NISWITCH_TOPOLOGY_1128_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_1129_2_WIRE_16X16_MATRIX 
    '''NISWITCH_TOPOLOGY_1129_2_WIRE_8X32_MATRIX 
    '''NISWITCH_TOPOLOGY_1129_2_WIRE_4X64_MATRIX 
    '''NISWITCH_TOPOLOGY_1129_2_WIRE_DUAL_8X16_MATRIX 
    '''NISWITCH_TOPOLOGY_1129_2_WIRE_DUAL_4X32_MATRIX 
    '''NISWITCH_TOPOLOGY_1129_2_WIRE_QUAD_4X16_MATRIX 
    '''NISWITCH_TOPOLOGY_1130_1_WIRE_256X1_MUX 
    '''NISWITCH_TOPOLOGY_1130_1_WIRE_4X64_MATRIX 
    '''NISWITCH_TOPOLOGY_1130_1_WIRE_8x32_MATRIX 
    '''NISWITCH_TOPOLOGY_1130_2_WIRE_4X32_MATRIX 
    '''NISWITCH_TOPOLOGY_1130_2_WIRE_128X1_MUX 
    '''NISWITCH_TOPOLOGY_1130_4_WIRE_64X1_MUX 
    '''NISWITCH_TOPOLOGY_1130_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_1160_16_SPDT 
    '''NISWITCH_TOPOLOGY_1161_8_SPDT 
    '''NISWITCH_TOPOLOGY_1163R_OCTAL_4X1_MUX 
    '''NISWITCH_TOPOLOGY_1166_32_SPDT 
    '''NISWITCH_TOPOLOGY_1167_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_1169_100_SPST 
    '''NISWITCH_TOPOLOGY_1190_QUAD_4X1_MUX 
    '''NISWITCH_TOPOLOGY_1191_QUAD_4X1_MUX 
    '''NISWITCH_TOPOLOGY_1192_8_SPDT 
    '''NISWITCH_TOPOLOGY_1193_32X1_MUX 
    '''NISWITCH_TOPOLOGY_1193_16X1_TERMINATED_MUX 
    '''NISWITCH_TOPOLOGY_1193_DUAL_16X1_MUX 
    '''NISWITCH_TOPOLOGY_1193_DUAL_8X1_TERMINATED_MUX 
    '''NISWITCH_TOPOLOGY_1193_QUAD_8X1_MUX 
    '''NISWITCH_TOPOLOGY_1193_QUAD_4X1_TERMINATED_MUX 
    '''NISWITCH_TOPOLOGY_1193_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_2501_1_WIRE_48X1_MUX 
    '''NISWITCH_TOPOLOGY_2501_1_WIRE_48X1_AMPLIFIED_MUX 
    '''NISWITCH_TOPOLOGY_2501_2_WIRE_24X1_MUX 
    '''NISWITCH_TOPOLOGY_2501_2_WIRE_24X1_AMPLIFIED_MUX 
    '''NISWITCH_TOPOLOGY_2501_2_WIRE_DUAL_12X1_MUX 
    '''NISWITCH_TOPOLOGY_2501_2_WIRE_QUAD_6X1_MUX 
    '''NISWITCH_TOPOLOGY_2501_2_WIRE_4X6_MATRIX 
    '''NISWITCH_TOPOLOGY_2501_4_WIRE_12X1_MUX 
    '''NISWITCH_TOPOLOGY_2503_1_WIRE_48X1_MUX 
    '''NISWITCH_TOPOLOGY_2503_2_WIRE_24X1_MUX 
    '''NISWITCH_TOPOLOGY_2503_2_WIRE_DUAL_12X1_MUX 
    '''NISWITCH_TOPOLOGY_2503_2_WIRE_QUAD_6X1_MUX 
    '''NISWITCH_TOPOLOGY_2503_2_WIRE_4X6_MATRIX 
    '''NISWITCH_TOPOLOGY_2503_4_WIRE_12X1_MUX 
    '''NISWITCH_TOPOLOGY_2529_2_WIRE_DUAL_4X16_MATRIX 
    '''NISWITCH_TOPOLOGY_2529_2_WIRE_8X16_MATRIX 
    '''NISWITCH_TOPOLOGY_2529_2_WIRE_4X32_MATRIX 
    '''NISWITCH_TOPOLOGY_2530_1_WIRE_128X1_MUX 
    '''NISWITCH_TOPOLOGY_2530_1_WIRE_4x32_MATRIX 
    '''NISWITCH_TOPOLOGY_2530_1_WIRE_8x16_MATRIX 
    '''NISWITCH_TOPOLOGY_2530_2_WIRE_4x16_MATRIX 
    '''NISWITCH_TOPOLOGY_2530_2_WIRE_64X1_MUX 
    '''NISWITCH_TOPOLOGY_2530_4_WIRE_32X1_MUX 
    '''NISWITCH_TOPOLOGY_2530_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_2532_1_WIRE_4X128_MATRIX 
    '''NISWITCH_TOPOLOGY_2532_1_WIRE_8X64_MATRIX 
    '''NISWITCH_TOPOLOGY_2532_1_WIRE_SIXTEEN_2X16_MATRIX 
    '''NISWITCH_TOPOLOGY_2565_16_SPST 
    '''NISWITCH_TOPOLOGY_2566_16_SPDT 
    '''NISWITCH_TOPOLOGY_2567_INDEPENDENT 
    '''NISWITCH_TOPOLOGY_2568_31_SPST 
    '''NISWITCH_TOPOLOGY_2569_100_SPST 
    '''NISWITCH_TOPOLOGY_2570_40_SPDT 
    '''NISWITCH_TOPOLOGY_2590_4X1_MUX 
    '''NISWITCH_TOPOLOGY_2591_4X1_MUX 
    '''NISWITCH_TOPOLOGY_2593_16X1_MUX 
    '''NISWITCH_TOPOLOGY_2593_8X1_TERMINATED_MUX 
    '''NISWITCH_TOPOLOGY_2593_DUAL_8X1_MUX 
    '''NISWITCH_TOPOLOGY_2593_DUAL_4X1_TERMINATED_MUX 
    '''NISWITCH_TOPOLOGY_2593_INDEPENDENT
    '''</param>
    '''<param name="Simulate">
    '''Enables simulation of the switch module specified in the resource name parameter.
    '''
    '''Valid Values: 
    '''VI_TRUE - Simulate 
    '''VI_FALSE - Don't Simulate (Default Value)
    '''</param>
    '''<param name="Reset_Device">
    '''Specifies whether to reset the switch module during the initialization process. 
    '''Valid Values: 
    '''VI_TRUE - Reset Device (Default Value) 
    '''VI_FALSE - Currently unsupported. The device will not reset.
    '''</param>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal Topology As String, ByVal Simulate As Boolean, ByVal Reset_Device As Boolean)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitWithTopology(Resource_Name, Topology, System.Convert.ToUInt16(Simulate), System.Convert.ToUInt16(Reset_Device), Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Creates a path between channel 1 and channel 2. The driver calculates and uses the shortest path between the two channels. Refer to Immediate Operations for information about Channel Usage types. 
    '''
    '''If a path is not available, the function returns one of the following errors: 
    '''- NISWITCH_ERROR_EXPLICIT_CONNECTION_EXISTS, if the two channels
    '''  are already explicitly connected by calling either the 
    '''  niSwitch_Connect or niSwitch_SetPath function. 
    '''  
    '''- NISWITCH_ERROR_IS_CONFIGURATION_CHANNEL, if a channel is a
    '''  configuration channel. Error elaboration contains information
    '''  about which of the two channels is a configuration channel. 
    '''
    '''- NISWITCH_ERROR_ATTEMPT_TO_CONNECT_SOURCES, if both channels
    '''  are connected to a different source. Error elaboration
    '''  contains information about sources channel 1 and 2 connect to.
    '''- NISWITCH_ERROR_CANNOT_CONNECT_TO_ITSELF, if channels 1 and 2
    '''  are one and the same channel. 
    '''- NISWITCH_ERROR_PATH_NOT_FOUND, if the driver cannot find a
    '''  path between the two channels. 
    '''  
    '''Note: Paths are bidirectional. For example, if a path exists between channels CH1 and CH2, then the path also exists between channels CH2 and CH1.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Channel_1">
    '''Input one of the channel names of the desired path. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: None 
    '''
    '''</param>
    '''<param name="Channel_2">
    '''Input one of the channel names of the desired path. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module. 
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: None 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function Connect(ByVal Channel_1 As String, ByVal Channel_2 As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.Connect(Me._handle, Channel_1, Channel_2)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function destroys the path between two channels that you create with the niSwitch_Connect or niSwitch_SetPath function.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Channel_1">
    '''Input one of the channel names of the path to break. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: None 
    '''
    '''</param>
    '''<param name="Channel_2">
    '''Input one of the channel names of the path to break. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module.
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: None 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function Disconnect(ByVal Channel_1 As String, ByVal Channel_2 As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.Disconnect(Me._handle, Channel_1, Channel_2)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Breaks all existing paths. 
    '''
    '''If the switch module cannot break all paths, NISWITCH_WARN_PATH_REMAINS warning is returned. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function DisconnectAll() As Integer
        Dim pInvokeResult As Integer = PInvoke.DisconnectAll(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Indicates if all created paths have settled by returning the value of the NISWITCH_ATTR_IS_DEBOUNCED attribute. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Is_Debounced">
    '''VI_TRUE indicates that all created paths have settled. VI_FALSE indicates that all created paths have not settled. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function IsDebounced(ByRef Is_Debounced As Boolean) As Integer
        Dim Is_DebouncedAsUShort As System.UInt16
        Dim pInvokeResult As Integer = PInvoke.IsDebounced(Me._handle, Is_DebouncedAsUShort)
        Is_Debounced = System.Convert.ToBoolean(Is_DebouncedAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Pauses until all created paths have settled. 
    '''
    '''If the time you specify with the Maximum Time (ms) parameter elapsed before the switch paths have settled, this function returns the NISWITCH_ERROR_MAX_TIME_EXCEEDED error.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Maximum_Time__ms_">
    '''Specifies the maximum length of time to wait for all relays in the switch module to activate or deactivate. If the specified time elapses before all relays active or deactivate, a timeout error is returned.
    '''
    '''Default Value:5000 ms
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function WaitForDebounce(ByVal Maximum_Time__ms_ As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.WaitForDebounce(Me._handle, Maximum_Time__ms_)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Verifies that a path between channel 1 and channel 2 can be created. 
    '''
    '''If a path is possible in the switch module, the availability of that path is returned given the existing connections. If the path is possible but in use, a NISWITCH_WARN_IMPLICIT_CONNECTION_EXISTS warning is returned.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Channel_1">
    '''Input one of the channel names of the desired path. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: ""
    '''</param>
    '''<param name="Channel_2">
    '''Input one of the channel names of the desired path. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module.
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: ""
    '''</param>
    '''<param name="Path_Capability">
    '''Indicates whether a path is valid. 
    '''Possible values include: 
    '''------------------------------------
    '''NISWITCH_VAL_PATH_AVAILABLE        1
    '''NISWITCH_VAL_PATH_EXISTS           2 
    '''NISWITCH_VAL_PATH_UNSUPPORTED      3 
    '''NISWITCH_VAL_RSRC_IN_USE           4 
    '''NISWITCH_VAL_SOURCE_CONFLICT       5 
    '''NISWITCH_VAL_CHANNEL_NOT_AVAILABLE 6 
    '''
    '''Notes: (1) NISWITCH_VAL_PATH_AVAILABLE indicates that the driver
    '''           can create the path at this time.
    '''       (2) NISWITCH_VAL_PATH_EXISTS   indicates  that  the  path
    '''           already exists. 
    '''       (3) NISWITCH_VAL_PATH_UNSUPPORTED    indicates  that  the
    '''           instrument is not capable of  creating a path between
    '''           the channels you specify. 
    '''       (4) NISWITCH_VAL_RSRC_IN_USE   indicates   that  although
    '''           the path is valid, the driver cannot  create the path
    '''           at this moment because the switch device is currently
    '''           using one or more of the required  channels to create
    '''           another path. You  must destroy the other path before
    '''           creating this one. 
    '''       (5) NISWITCH_VAL_SOURCE_CONFLICT   indicates   that   the
    '''           instrument cannot create a path because both channels
    '''           are connected to a different source channel. 
    '''       (6) NISWITCH_VAL_CHANNEL_NOT_AVAILABLE indicates that the
    '''           driver cannot create a path  between the two channels
    '''           because  one  of  the  channels  is  a  configuration
    '''           channel    and    thus  unavailable   for    external
    '''           connections.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function CanConnect(ByVal Channel_1 As String, ByVal Channel_2 As String, ByRef Path_Capability As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CanConnect(Me._handle, Channel_1, Channel_2, Path_Capability)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Connects two channels by specifying an explicit path in the path list parameter. niSwitch_SetPath is particularly useful where path repeatability is important, such as in calibrated signal paths. If this is not necessary, use niSwitch_Connect. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Path_List">
    '''A string composed of comma-separated paths between channel 1 and channel 2. The first and last names in the path are the endpoints of the path. Every other channel in the path are configuration channels.
    '''
    '''Example of a valid path list string:
    '''
    '''ch0-&gt;com0, com0-&gt;ab0.
    '''
    '''In this example, com0 is a configuration channel.
    '''
    '''Default value: None 
    '''
    '''Obtain the path list for a previously created path with niSwitch_GetPath. 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function SetPath(ByVal Path_List As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetPath(Me._handle, Path_List)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns a string that identifies the explicit path created with niSwitch_Connect. Pass this string to niSwitch_SetPath to establish the exact same path in future connections. 
    '''
    '''In some cases, multiple paths are available between two channels. When you call niSwitch_Connect, the driver selects an available path. With niSwitch_Connect, there is no guarantee that the driver selected path will always be the same path through the switch module.
    '''
    '''niSwitch_GetPath only returns those paths explicitly created by niSwitch Connect Channels or niSwitch_SetPath. For example, if you connect channels CH1 and CH3,and then channels CH2 and CH3, an explicit path between channels CH1 and CH2 does not exist an error is returned
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Channel_1">
    '''Input one of the channel names of the desired path. Pass the other channel name as the channel 2 parameter. Refer to Devices Overview for valid channel names for the switch module.
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: ""
    '''</param>
    '''<param name="Channel_2">
    '''Input one of the channel names of the desired path. Pass the other channel name as the channel 1 parameter. Refer to Devices Overview for valid channel names for the switch module. 
    '''
    '''Examples of valid channel names: 
    '''
    '''ch0, com0, ab0, r1, c2, cjtemp
    '''
    '''Default value: ""
    '''</param>
    '''<param name="Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the Path List parameter. If the current value of the attribute, including the terminating NULL byte, contains more bytes that you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "R1-&gt;C1" and the Buffer Size is 4, the function places "R1-" into the buffer and returns 7. If you pass 0, you can pass VI_NULL for the Path parameter. This enables you to find out the path size and to allocate the buffer of the appropriate size before calling this function again.
    '''</param>
    '''<param name="Path">
    '''A string composed of comma-separated paths between channel 1 and channel 2. The first and last names in the path are the endpoints of the path. All other channels in the path are configuration channels.
    '''
    '''Examples of returned paths:
    '''
    '''ch0-&gt;com0, com0-&gt;ab0 
    '''
    '''</param>
    '''<returns>
    '''Contains the status code that the function call returns. If the function succeeds and the buffer you pass is large enough to hold the entire value, the function returns VI_SUCCESS. If the current value of the attribute, including the terminating NULL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
    '''Negative values indicate an error. You examine the status code from each call to an instrument driver function to determine if an error occurred. To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetPath(ByVal Channel_1 As String, ByVal Channel_2 As String, ByVal Buffer_Size As Integer, ByVal Path As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetPath(Me._handle, Channel_1, Channel_2, Buffer_Size, Path)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function is a high level operation for scanning. It takes the scan list provided, programs the switching hardware and initiates the scan. Once initiation is complete, the operation will return. The scan list itself is comprised of a list of channel connections separated by semicolons. 
    '''
    '''For example, the following scan list would scan the first three channels of a multiplexer. 
    '''
    '''Example: com0-&gt;ch0; com0-&gt;ch1; com0-&gt;ch2; 
    '''
    '''For more information on scan list syntax, refer to the NI Switches Help. To see the status of the scan, you can call either niSwitch_IsScanning or niSwitch_WaitForScanComplete. Use the niSwitch_ConfigureScanTrigger function to configure the scan trigger. Use the niSwitch_AbortScan function to stop the scan if you are in continuous scan mode (Refer to niSwitch_SetContinuousScan); otherwise the scan halts automatically when the end of the scan list is reached. For reference, this operation is equivalent to calling niSwitch_ConfigureScanList and niSwitch_InitiateScan.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Scanlist">
    '''Pass the scan list you want the instrument to use. 
    '''The driver uses this value to set the NISWITCH_ATTR_SCAN_LIST attribute. The scan list is a string that specifies channel connections and trigger conditions for scanning. After you call the niSwitch_InitiateScan function, the instrument makes or breaks connections and waits for triggers according to the instructions in the scan list. The scan list is comprised of channel names that you separate with special characters. These special characters determine the operation the scanner performs on the channels when it executes this scan list. 
    '''
    '''To create a path between two channels, use '-&gt;' (a dash followed by a '&gt;' sign) between the two channel names. 
    '''
    '''Example: 
    '''"CH1-&gt;CH2" instructs the switch to make a path from channel
    '''              CH1 to channel CH2. 
    '''
    '''To break or clear a path, use a '~' (tilde) as a prefix before the path. 
    '''
    '''Example: 
    '''"~CH1-&gt;CH2" instructs the switch to break the path from
    '''               channel CH1 to channel CH2. 
    '''
    '''To wait for a trigger event, use a ';' (semicolon) as a separator between paths. 
    '''
    '''Example: 
    '''"CH1-&gt;CH2;CH3-&gt;CH4" instructs the switch to make the path
    '''                          from channel CH1 to channel CH2, wait
    '''                          for a trigger, and then make the path
    '''                          from CH3 to CH4. 
    '''
    '''To tell the switch device to create multiple paths simultaneously, use an '&amp;' (ampersand) character as a separator between the paths. 
    '''
    '''Example: 
    '''"CH0-&gt;CH1; CH1-&gt;CH2 &amp; CH3-&gt;CH4" instructs the
    '''         scanner to make the path between channels CH0 and CH1,
    '''         wait for a trigger, and then simultaneously make the
    '''         paths between channels CH1 and CH2 and between channels
    '''         CH3 and CH4. 
    '''         
    '''For SCXI use the following syntax : 
    '''- For a single channel: sc&lt;chassis ID number&gt;!md&lt;module slot number&gt;!ch&lt;channel number&gt; -&gt; com0; 
    '''
    '''For example: for Chassis 1, module in slot 3, and ch 30 the syntax is: 
    '''sc1!md3!ch30 -&gt;com0; 
    '''
    '''For multiple sequential channels: 
    '''sc&lt;chassis ID number&gt;!md&lt;module slot number&gt;!ch&lt;channel number to start with: channel number to end with&gt; -&gt; com0; 
    '''
    '''For example: for Chassis 1, module in slot 3, and ch 30 to 19 the syntax is: 
    '''sc1!md3!ch30:19 -&gt;com0; will scan from channel 30 to 19 sequentially. 
    '''
    '''For multiple randomly ordered channels: sc&lt;chassis ID number&gt;!md&lt;module slot number&gt;!ch&lt;channel number&gt; -&gt; com0; sc&lt;chassis ID number&gt;!md&lt;next module slot number&gt;!ch&lt;next channel number&gt; -&gt; com0; 
    '''
    '''For example: for Chassis 1, module in slot 3 and slot 4, and ch 30 and 5 on slot 3 and channel 19 on slot 4the syntax is: 
    '''sc1!md3!ch30 -&gt;com0; sc1!md4!ch19 -&gt;com0; sc1!md3!ch5 -&gt;com0; 
    '''
    '''This will scan ch30 of slot 3 then ch19 of slot 4 then ch5 of slot3. 
    '''
    '''For more information on scan list syntax, refer to the NI Switches Help. 
    '''
    '''Default Value: None
    '''</param>
    '''<param name="Initiation">
    '''Use the initiation paramater to specify whether the switch device or the measurement device will be initiating the scan trigger handshake. This parameter determines whether to wait for the scan to reach a trigger point before completing. 
    '''If the Measurement Device will initiate the scan, set this parameter to NISWITCH_VAL_MEASUREMENT_DEVICE_INITIATED. This function will then wait until the switch is waiting for a trigger from the measurement device before completing. 
    '''If the Switch will initiate the scan, set this parameter to NISWITCH_VAL_SWITCH_INITIATED. This function will then complete immediately after initating the scan. 
    '''You should have already set up your DMM to wait for a trigger before calling this function with Initiation set to NISWITCH_VAL_SWITCH_INITIATED.
    '''
    '''Valid values: 
    '''NISWITCH_VAL_SWITCH_INITIATED             - Switch Initiated
    '''NISWITCH_VAL_MEASUREMENT_DEVICE_INITIATED - Measurement device 
    '''                                            initiated
    '''
    '''Default value: NISWITCH_VAL_MEASUREMENT_DEVICE_INITIATED
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function Scan(ByVal Scanlist As String, ByVal Initiation As Short) As Integer
        Dim pInvokeResult As Integer = PInvoke.Scan(Me._handle, Scanlist, Initiation)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Commits the configured scan list and trigger settings to hardware and initiates the scan. If niSwitch Commit was called earlier, niSwitch Initiate Scan only initiates the scan and returns immediately. 
    '''
    '''Once the scanning operation begins, you cannot perform any other operation other than GetAttribute, AbortScan, or SendSoftwareTrigger. All other functions return NISWITCH_ERROR_SCAN_IN_PROGRESS. To stop the scanning operation, 
    '''
    '''To stop the scanning operation, call niSwitch_AbortScan.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function InitiateScan() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitiateScan(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Aborts the scan in progress. 
    '''
    '''Initiate a scan with niSwitch_InitiateScan.
    '''
    '''If the switch module is not scanning,  NISWITCH_ERROR_NO_SCAN_IN_PROGRESS error is returned.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function AbortScan() As Integer
        Dim pInvokeResult As Integer = PInvoke.AbortScan(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Sends a software trigger to the switch module specified in the NI-SWITCH session. When the trigger input is set to NISWITCH_VAL_SOFTWARE_TRIG through either the niSwitch_ConfigureScanTrigger or the NISWITCH_ATTR_TRIGGER_INPUT attribute, the scan does not proceed from a semi-colon (wait for trigger) until niSwitch_SendSoftwareTrigger is called. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function SendSoftwareTrigger() As Integer
        Dim pInvokeResult As Integer = PInvoke.SendSoftwareTrigger(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Indicates the status of the scan. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Is_Scanning">
    '''The driver returns the value of NISWITCH_ATTR_IS_SCANNING attribute. VI_TRUE indicates that the switch device is scanning. VI_FALSE indicates that the switch device is idle.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function IsScanning(ByRef Is_Scanning As Boolean) As Integer
        Dim Is_ScanningAsUShort As System.UInt16
        Dim pInvokeResult As Integer = PInvoke.IsScanning(Me._handle, Is_ScanningAsUShort)
        Is_Scanning = System.Convert.ToBoolean(Is_ScanningAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Pauses until the switch module stops scanning or the maximum time has elapsed and returns a timeout error. 
    '''
    '''If the time you specify with the Maximum Time (ms) parameter elapsed before the scanning operation has finished, this function returns the NISWITCH_ERROR_MAX_TIME_EXCEEDED error.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Maximum_Time__ms_">
    '''Specifies the maximum length of time to wait for the switch module to stop scanning. If the specified time elapses before the scan ends, NISWITCH_ERROR_MAX_TIME_EXCEEDED error is returned.
    '''
    '''Default Value:5000 ms
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function WaitForScanComplete(ByVal Maximum_Time__ms_ As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.WaitForScanComplete(Me._handle, Maximum_Time__ms_)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Sets the to loop continuously through the scan list or to stop scanning after one pass through the scan list. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Continuous_Scan">
    '''If VI_TRUE, loops continuously through the scan list during scanning. If VI_FALSE, the scan stops after one pass through the scan list.
    '''
    '''Default value: VI_FALSE 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function SetContinuousScan(ByVal Continuous_Scan As Boolean) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetContinuousScan(Me._handle, System.Convert.ToUInt16(Continuous_Scan))
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the scan list and scan mode used for scanning. 
    '''
    '''Refer to Devices Overview to determine if the switch module supports scanning.
    '''
    '''The scan list is comprised of a list of channel connections separated by semi-colons. For example, the following scan list will scan the first three channels of a multiplexer:
    '''
    '''com0-&gt;ch0; com0-&gt;ch1; com0-&gt;ch2;
    '''
    '''Refer to Scan Lists for more information on scan list syntax
    '''
    '''To see the status of the scan, call either niSwitch_IsScanning or niSwitch_WaitForScanComplete. Use the niSwitch_ConfigureScanTrigger function to configure the scan trigger. Use the niSwitch_InitiateScan function to start the scan.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Scanlist">
    '''The scan list to use. The driver uses this value to set the Scan List attribute.
    '''
    '''Default value: None 
    '''
    '''</param>
    '''<param name="Scan_Mode">
    '''Specifies how the switch module breaks existing connections when scanning. The driver uses this value to set the Scan Mode attribute. Refer to scan modes for more information.
    '''
    '''Default value: Break Before Make 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function ConfigureScanList(ByVal Scanlist As String, ByVal Scan_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureScanList(Me._handle, Scanlist, Scan_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the scan triggers for the scan list established with niSwitch_ConfigureScanList. 
    '''
    '''Refer to Devices Overview to determine if the switch module supports scanning.
    '''
    '''niSwitch_ConfigureScanTrigger sets the location that the switch expects to receive an input trigger to advance through the scan list. This function also sets the location where it outputs a scan advanced signal after it completes an entry in the scan list.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Scan_Delay">
    '''The minimum length of time you want the switch device to wait after it creates a path until it asserts a trigger on the scan advanced output line. The driver uses this value to set the Scan Delay attribute. The scan delay is in addition to the settling time.The driver uses this value to set the NISWITCH_ATTR_SCAN_DELAY attribute. 
    '''
    '''Express this value in seconds. 
    '''
    '''Default value: 0.0 s
    '''</param>
    '''<param name="Trigger_Input">
    '''Trigger source you want the switch module to use during scanning. The driver uses this value to set the NISWITCH_ATTR_TRIGGER_INPUT attribute. The switch device waits for the trigger you specify when it encounters a semicolon in the scanlist. When the trigger occurs, the switch device advances to the next entry in the scanlist. Refer to the NISWITCH_ATTR_TRIGGER_INPUT topic in the NI Switches Help for a list of valid values.
    '''
    '''
    '''</param>
    '''<param name="Scan_Advanced_Output">
    '''Output destination of the scan advanced trigger signal. The driver uses this value to set the NISWITCH_ATTR_SCAN_ADVANCED_OUTPUT attribute. After the switch processes each entry in the scan list, it waits the length of time you specify in the Scan Delay parameter and then asserts a trigger on the line you specify with this parameter. Refer to the NISWITCH_ATTR_SCAN_ADVANCED_OUTPUT topic in the NI Switches Help for a list of valid values.
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function ConfigureScanTrigger(ByVal Scan_Delay As Double, ByVal Trigger_Input As Integer, ByVal Scan_Advanced_Output As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureScanTrigger(Me._handle, Scan_Delay, Trigger_Input, Scan_Advanced_Output)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Routes the input trigger from the front or rear connector to a trigger bus line (TTLx). To disconnect the route, call this function again and specify None for trigger bus line parameter. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Trigger_Input_Connector">
    '''The location of the input trigger source on the switch module. Valid locations are the NISWITCH_VAL_FRONTCONNECTOR and NISWITCH_VAL_REARCONNECTOR.
    '''
    '''Default value: NISWITCH_VAL_FRONTCONNECTOR
    '''
    '''</param>
    '''<param name="Trigger_Input_Bus_Line">
    '''The trigger line to route the input trigger. Select NISWITCH_VAL_NONE to break an existing route.
    '''
    '''Default value: None 
    '''
    '''Valid Values:
    '''
    '''NISWITCH_VAL_NONE
    '''NISWITCH_VAL_TTL0
    '''NISWITCH_VAL_TTL1
    '''NISWITCH_VAL_TTL2
    '''NISWITCH_VAL_TTL3
    '''NISWITCH_VAL_TTL4
    '''NISWITCH_VAL_TTL5
    '''NISWITCH_VAL_TTL6
    '''NISWITCH_VAL_TTL7
    '''
    '''
    '''</param>
    '''<param name="Invert">
    '''If VI_TRUE, inverts the input trigger signal from falling to rising or vice versa.
    '''
    '''Default value: VI_FALSE 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function RouteTriggerInput(ByVal Trigger_Input_Connector As Integer, ByVal Trigger_Input_Bus_Line As Integer, ByVal Invert As Boolean) As Integer
        Dim pInvokeResult As Integer = PInvoke.RouteTriggerInput(Me._handle, Trigger_Input_Connector, Trigger_Input_Bus_Line, System.Convert.ToUInt16(Invert))
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Routes the scan advanced output trigger from a trigger bus line (TTLx) to the front or rear connector. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Scan_Advanced_Output_Connector">
    '''The scan advanced trigger destination. Valid locations are the NISWITCH_VAL_FRONTCONNECTOR and NISWITCH_VAL_REARCONNECTOR.
    '''
    '''Default value: NISWITCH_VAL_FRONTCONNECTOR
    '''
    '''</param>
    '''<param name="Scan_Advanced_Output_Bus_Line">
    '''The trigger line to route the scan advanced output trigger from the front or rear connector. Select NISWITCH_VAL_NONE to break an existing route.
    '''
    '''Default value: None 
    '''
    '''Valid Values:
    '''
    '''NISWITCH_VAL_NONE
    '''NISWITCH_VAL_TTL0
    '''NISWITCH_VAL_TTL1
    '''NISWITCH_VAL_TTL2
    '''NISWITCH_VAL_TTL3
    '''NISWITCH_VAL_TTL4
    '''NISWITCH_VAL_TTL5
    '''NISWITCH_VAL_TTL6
    '''NISWITCH_VAL_TTL7
    '''</param>
    '''<param name="Invert">
    '''If VI_TRUE, inverts the input trigger signal from falling to rising or vice versa.
    '''
    '''Default value: VI_FALSE 
    '''
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function RouteScanAdvancedOutput(ByVal Scan_Advanced_Output_Connector As Integer, ByVal Scan_Advanced_Output_Bus_Line As Integer, ByVal Invert As Boolean) As Integer
        Dim pInvokeResult As Integer = PInvoke.RouteScanAdvancedOutput(Me._handle, Scan_Advanced_Output_Connector, Scan_Advanced_Output_Bus_Line, System.Convert.ToUInt16(Invert))
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the relay name string that is in the relay list at the specified index. 
    '''
    '''Use niSwitch_GetRelayName in a For Loop to get a complete list of valid relay names for the switch module. Use the Number of Relays attribute to determine the number of relays. 
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Index">
    '''A 1-based index into the channel table.
    '''
    '''Default value: 1
    '''
    '''Maximum value: Value of Channel Count attribute. 
    '''
    '''</param>
    '''<param name="Relay_Name_Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the Relay Name Buffer parameter. If the relay name string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. Default Value: None
    '''</param>
    '''<param name="Relay_Name_Buffer">
    '''Returns the relay name for the index you specify.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
    '''
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetRelayName(ByVal Index As Integer, ByVal Relay_Name_Buffer_Size As Integer, ByVal Relay_Name_Buffer As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetRelayName(Me._handle, Index, Relay_Name_Buffer_Size, Relay_Name_Buffer)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the number of times the relay has changed from Closed to Open. Relay count is useful for tracking relay lifetime and usage. Call niSwitch_WaitForDebounce before niSwitch_GetRelayCount to ensure an accurate count.
    '''
    '''Refer to Devices Overview of the NI Switches Help to determine if the switch module supports individual relay control.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Relay_Name">
    '''Name of the relay.
    '''
    '''Default value: None
    '''
    '''Examples of valid relay names:
    '''
    '''ch0, ab0, 1wire, hlselect 
    '''
    '''Refer to Devices Overview for a list of valid relay names for the switch module.
    '''
    '''</param>
    '''<param name="Relay_Count">
    '''The number of relay cycles. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetRelayCount(ByVal Relay_Name As String, ByRef Relay_Count As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetRelayCount(Me._handle, Relay_Name, Relay_Count)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the relay position for the relay specified in the Relay Name parameter.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Relay_Name">
    '''Name of the relay.
    '''
    '''Default value: None
    '''
    '''Examples of valid relay names:
    '''
    '''ch0, ab0, 1wire, hlselect 
    '''
    '''Refer to Devices Overview for a list of valid relay names for the switch module.
    '''
    '''</param>
    '''<param name="Relay_Position">
    '''Indicates whether the relay is open or closed. 
    '''
    '''NISWITCH_VAL_OPEN       10
    '''NIWITCH_VAL_CLOSED      11 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetRelayPosition(ByVal Relay_Name As String, ByRef Relay_Position As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetRelayPosition(Me._handle, Relay_Name, Relay_Position)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Controls individual relays of the switch module. When controlling individual relays, the protection offered by setting the usage of source channels and configurations channels is void. 
    '''
    '''Refer to Devices Overview to determine if the switch module supports individual relay control. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Relay_Name">
    '''Name of the relay.
    '''
    '''Default value: None
    '''
    '''Examples of valid relay names:
    '''
    '''ch0, ab0, 1wire, hlselect 
    '''
    '''Refer to Devices Overview for a list of valid relay names for the switch module.
    '''
    '''</param>
    '''<param name="Relay_Action">
    '''Specifies whether to open or close a given relay.
    '''
    '''Default value: Relay Close 
    '''
    '''Defined values:
    '''NISWITCH_VAL_OPEN_RELAY
    '''NISWITCH_VAL_CLOSE_RELAY (Default Value)
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function RelayControl(ByVal Relay_Name As String, ByVal Relay_Action As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.RelayControl(Me._handle, Relay_Name, Relay_Action)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Downloads the configured scan list and trigger settings to hardware. 
    '''
    '''Calling niSwitch_Commit optional as it is implicitly called during niSwitch_InitiateScan. Use niSwitch_Commit to arm triggers in a given order or to control when expensive hardware operations are performed. 
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function Commit() As Integer
        Dim pInvokeResult As Integer = PInvoke.Commit(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the channel string that is in the channel table at the specified index. 
    '''
    '''Use niSwitch_GetChannelName in a For Loop to get a complete list of valid channel names for the switch module. Use the Channel Count attribute to determine the number of channels. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Index">
    '''A 1-based index into the channel table.
    '''
    '''Default value: 1
    '''
    '''Maximum value: Value of Channel Count attribute. 
    '''
    '''</param>
    '''<param name="Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the Channel Name Buffer parameter. If the channel name string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. Default Value: None
    '''</param>
    '''<param name="Channel_Name_Buffer">
    '''Returns the channel name that is in the channel table at the index you specify.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
    '''
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetChannelName(ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_Name_Buffer As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetChannelName(Me._handle, Index, Buffer_Size, Channel_Name_Buffer)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Disconnects all created paths and returns the switch module to the state at initialization. Configuration channel and source channel settings remain unchanged. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function reset() As Integer
        Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Resets the switch module and applies initial user specified settings from the logical name used to initialize the session. If the session was created without a logical name, this function is equivalent to niSwitch_reset. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function ResetWithDefaults() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetWithDefaults(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Places the switch module in a quiescent state where it has minimal or no impact on the system to which it is connected. All channels are disconnected and any scan in progress is aborted. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function Disable() As Integer
        Dim pInvokeResult As Integer = PInvoke.Disable(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Verifies that the driver can communicate with the switch module.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Self_Test_Result">
    '''Value returned from the switch device self-test. 
    '''
    '''Passed   0
    '''Failed   1
    '''</param>
    '''<param name="Self_Test_Message">
    '''Self-test response string from the switch device.  You must pass a ViChar array with at least 256 bytes.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the revision of the NI-SWITCH driver. 
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Instrument_Driver_Revision">
    '''NI-SWITCH software revision numbers in the form of a string.  You must pass a ViChar array with at least 256 bytes.
    '''</param>
    '''<param name="Firmware_Revision">
    '''Currently unsupported. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function reads an error code and a message from the instrument's error queue.
    '''NI-SWITCH does not have an error queue, so this function never returns any errors.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Error_Code">
    '''Returns the error code read from the instrument's error queue.
    '''NI-SWITCH does not have an error queue, so this function never returns any errors.
    '''</param>
    '''<param name="Error_Message">
    '''Returns the error message string read from the instrument's error message queue. You must pass a ViChar array with at least 256 bytes.
    '''NI-SWITCH does not have an error queue, so this function never returns anything other than "No error".
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function error_query(ByRef Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.error_query(Me._handle, Error_Code, Error_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function returns the coercion information associated with the IVI session. This function retrieves and clears the oldest instance in which the instrument driver coerced a value you specified to another value. 
    '''                     
    '''If you set the NISWITCH_ATTR_RECORD_COERCIONS attribute to VI_TRUE, the instrument driver keeps a list of all coercions it makes on ViInt32 or ViReal64 values you pass to instrument driver functions. You use this function to retrieve information from that list. If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. The function returns an empty string in the Coercion Record parameter if no coercion records remain for the session.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the Coercion Record parameter. 
    '''If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Coercion Record buffer parameter. Default Value: None
    '''</param>
    '''<param name="Coercion_Record">
    '''Returns the next coercion record for the IVI session. If there are no coercion records, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter. 
    '''If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate with the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. This parameter returns an empty string if no coercion records remain for the session.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
    '''
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetNextCoercionRecord(ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextCoercionRecord(Me._handle, Buffer_Size, Coercion_Record)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. You use this function to retrieve interchangeability warnings. The driver performs interchangeability checking when the NISWITCH_ATTR_INTERCHANGE_CHECK attribute is set to VI_TRUE. The function returns an empty string in the Interchange Warning parameter if no interchangeability warnings remain for the session. In general, the instrument driver generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<param name="Buffer_Size">
    '''Pass the number of bytes in the ViChar array you specify for the Interchange Warning parameter. 
    '''If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. If you pass 0, you can pass VI_NULL for the Interchange Warning buffer parameter. Default Value: None
    '''</param>
    '''<param name="Interchange_Warning">
    '''Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter. 
    '''If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate with the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. This parameter returns an empty string if no interchangeability warnings remain for the session.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
    '''
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function GetNextInterchangeWarning(ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextInterchangeWarning(Me._handle, Buffer_Size, Interchange_Warning)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function clears the list of current interchange warnings.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function ClearInterchangeWarnings() As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearInterchangeWarnings(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order. To do so requires ensuring that each test module completely configures the state of each instrument it uses. If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module. If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change. This change in behavior is generally instrument specific and represents an interchangeability problem. 
    '''
    '''You can use this function to test for such cases. After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations. By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules. This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings. If you want to guarantee that the niSwitch_GetNextInterchangeWarning function only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings. You can clear the interchangeability warnings list by repeatedly calling the niSwitch_GetNextInterchangeWarning function until no more interchangeability warnings are returned. If you are not interested in the content of those warnings, you can call the niSwitch_ClearInterchangeWarnings function.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''A particular NI-SWITCH session established with niSwitch_InitWithTopology, niSwitch_InitWithOptions, or niSwitch_init and used for all subsequent NI-SWITCH calls.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation. The status code either indicates success or describes an error or warning condition. You examine the status code from each call to an instrument driver function to determine if an error occurred. 
    '''To obtain a text description of the status code, call the niSwitch_error_message function. To obtain additional information about the error condition, call the niSwitch_GetError function. To clear the error information from the driver, call the niSwitch_ClearError function. 
    '''The general meaning of the status code is as follows: 
    '''Value    Meaning 
    '''------------------------------- 
    '''0        Success 
    '''Positive Values Warnings 
    '''Negative Values Errors 
    '''
    '''This driver defines the following status codes: 
    '''Status    Description 
    '''------------------------------------------------- 
    '''BFFA4001  Another process has already opened a session to this
    '''          switch module.
    '''BFFA4002  Invalid Resource Name or Instrument Descriptor
    '''BFFA4003  You have set an attribute or called a function that is
    '''          only used for scanning, and  this  switch  module does
    '''          not support scanning (or this module does not support
    '''          scanning in the current configuration).
    '''BFFA4004  You have indicated that a non-cabled module should 
    '''          get its trigger from the rear connector, and the
    '''          niSwitch software could not automatically detect
    '''          which cabled module to route the trigger from. Be 
    '''          more specific (ie, specify Rear Connector of Module
    '''          X).
    '''BFFA4005  The scanlist command  exceeds the size of  memory  on
    '''          the switch module.
    '''BFFA4006  Error communicating  with  hardware. Internal timeout
    '''          occurred waiting for hardware response.
    '''BFFA4007  Expecting trigger or scan advanced  bus  to be one of
    '''          the TTL lines (TTL0-TTL7).
    '''BFFA4008  This module requires scan mode to be BreakBeforeMake
    '''BFFA4009  TTL 1 Conflict Detected. SCXI 1127 modules constantly
    '''          use the TTL1 line. Use a different line,or power down
    '''          the chassis and remove all 1127 modules from it.
    '''BFFA400B  The driver setup string is invalid.
    '''BFFA400C  No legacy device supports the specified topology. Use
    '''          a different  topology, or configure the  device under
    '''          DAQmx and use the DAQmx resource descriptor.
    '''BFFA400D  The specified topology string is invalid.
    '''BFFA400E  The device  was  unexpectedly power cycled. Close and
    '''          re-open the session.
    '''BFFA400F  The values  for  Handshaking Initiation  and  Trigger
    '''          Input are incompatible. An Immediate Trigger Input is
    '''          not compatible  with Measurement Device Initiated (or
    '''          DMM Initiated) Handshaking Initiation.
    '''BFFA4010  A legacy  resource descriptor  was specified, but the
    '''          driver setup string specifies a DAQmx resource type.
    '''BFFA4011  A  DAQmx  resource descriptor was specified,  but the
    '''          driver setup string specifies a Legacy resource type.
    '''BFFA4012  Model code  specified in the  driver  setup string is
    '''          ambiguous.Multiple switches match the specified model
    '''          code.
    '''BFFA4013  The  trigger input you  specified is not supported by
    '''          the device.
    '''
    '''
    '''This instrument driver also returns errors and warnings defined by other sources. 
    '''The following table defines the ranges of additional status codes that this driver can return. The table lists the different include files that contain the defined constants for the particular status codes: 
    '''Numeric Range (in Hex) Status Code Types 
    '''------------------------------------------------- 
    '''3FFA2000 to 3FFA3FFF IviSwtch Warnings 
    '''3FFA0000 to 3FFA1FFF IVI Warnings 
    '''3FFF0000 to 3FFFFFFF VISA Warnings 
    '''3FFC0000 to 3FFCFFFF VXIPnP Driver Warnings 
    '''3FFA4800 to 3FFA4BFF NI-DAQmx Warnings
    '''3FFA6000 to 3FFA63FF Traditional NI-DAQ Warnings
    '''3FFA6400 to 3FFA67FF NI-PAL Warnings
    '''
    '''BFFA2000 to BFFA3FFF IviSwtch Errors 
    '''BFFA0000 to BFFA1FFF IVI Errors 
    '''BFFF0000 to BFFFFFFF VISA Errors 
    '''BFFC0000 to BFFCFFFF VXIPnP Driver Errors
    '''BFFA4800 to BFFA4BFF NI-DAQmx Errors
    '''BFFA6000 to BFFA63FF Traditional NI-DAQ Errors
    '''BFFA6400 to BFFA67FF NI-PAL Errors
    '''</returns>
    Public Function ResetInterchangeCheck() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetInterchangeCheck(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        Me.Dispose(true)
        System.GC.SuppressFinalize(Me)
    End Sub
    
    Private Overloads Sub Dispose(ByVal disposing As Boolean)
        If (Me._disposed = false) Then
            PInvoke.close(Me._handle)
            Me._handle = System.IntPtr.Zero
        End If
        Me._disposed = true
    End Sub
    
    Protected Overrides Sub Finalize()
        Me.Dispose(false)
    End Sub
    
    Public Overloads Sub SetInt32(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetInt32(ByVal propertyId As niSwitchProperties, ByVal val As Integer)
        Me.SetInt32(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetInt32(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
        Dim val As Integer
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetInt32(ByVal propertyId As niSwitchProperties) As Integer
        Return Me.GetInt32(propertyId, "")
    End Function
    
    Public Overloads Sub SetDouble(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetDouble(ByVal propertyId As niSwitchProperties, ByVal val As Double)
        Me.SetDouble(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetDouble(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String) As Double
        Dim val As Double
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetDouble(ByVal propertyId As niSwitchProperties) As Double
        Return Me.GetDouble(propertyId, "")
    End Function
    
    Public Overloads Sub SetBoolean(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), System.Convert.ToUInt16(val)))
    End Sub
    
    Public Overloads Sub SetBoolean(ByVal propertyId As niSwitchProperties, ByVal val As Boolean)
        Me.SetBoolean(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetBoolean(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
        Dim val As System.UInt16
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return System.Convert.ToBoolean(val)
    End Function
    
    Public Overloads Function GetBoolean(ByVal propertyId As niSwitchProperties) As Boolean
        Return Me.GetBoolean(propertyId, "")
    End Function
    
    Public Overloads Sub SetString(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetString(ByVal propertyId As niSwitchProperties, ByVal val As String)
        Me.SetString(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetString(ByVal propertyId As niSwitchProperties, ByVal repeatedCapabilityOrChannel As String) As String
        Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
        Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), 512, newVal)
        If (size < 0) Then
            PInvoke.ThrowError(Me._handle, size)
        Else
            If (size > 0) Then
                newVal.Capacity = size
                PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), size, newVal))
            End If
        End If
        Return newVal.ToString
    End Function
    
    Public Overloads Function GetString(ByVal propertyId As niSwitchProperties) As String
        Return Me.GetString(propertyId, "")
    End Function
    
    Private Class PInvoke
        
        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_init", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function init (ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset_Device As System.UInt16, ByRef Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitWithOptions (ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset_Device As System.UInt16, ByVal Options_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_InitWithTopology", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitWithTopology (ByVal Resource_Name As String, ByVal Topology As String, ByVal Simulate As System.UInt16, ByVal Reset_Device As System.UInt16, ByRef Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_Connect", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Connect (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_1 As String, ByVal Channel_2 As String) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_Disconnect", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Disconnect (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_1 As String, ByVal Channel_2 As String) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_DisconnectAll", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisconnectAll (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_IsDebounced", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function IsDebounced (ByVal Instrument_Handle As System.IntPtr, ByRef Is_Debounced As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_WaitForDebounce", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WaitForDebounce (ByVal Instrument_Handle As System.IntPtr, ByVal Maximum_Time__ms_ As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_CanConnect", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CanConnect (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_1 As String, ByVal Channel_2 As String, ByRef Path_Capability As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetPath", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetPath (ByVal Instrument_Handle As System.IntPtr, ByVal Path_List As String) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetPath", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetPath (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_1 As String, ByVal Channel_2 As String, ByVal Buffer_Size As Integer, ByVal Path As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_Scan", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Scan (ByVal Instrument_Handle As System.IntPtr, ByVal Scanlist As String, ByVal Initiation As Short) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_InitiateScan", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitiateScan (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_AbortScan", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AbortScan (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SendSoftwareTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SendSoftwareTrigger (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_IsScanning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function IsScanning (ByVal Instrument_Handle As System.IntPtr, ByRef Is_Scanning As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_WaitForScanComplete", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WaitForScanComplete (ByVal Instrument_Handle As System.IntPtr, ByVal Maximum_Time__ms_ As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetContinuousScan", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetContinuousScan (ByVal Instrument_Handle As System.IntPtr, ByVal Continuous_Scan As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_ConfigureScanList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureScanList (ByVal Instrument_Handle As System.IntPtr, ByVal Scanlist As String, ByVal Scan_Mode As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_ConfigureScanTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureScanTrigger (ByVal Instrument_Handle As System.IntPtr, ByVal Scan_Delay As Double, ByVal Trigger_Input As Integer, ByVal Scan_Advanced_Output As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_RouteTriggerInput", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RouteTriggerInput (ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Input_Connector As Integer, ByVal Trigger_Input_Bus_Line As Integer, ByVal Invert As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_RouteScanAdvancedOutput", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RouteScanAdvancedOutput (ByVal Instrument_Handle As System.IntPtr, ByVal Scan_Advanced_Output_Connector As Integer, ByVal Scan_Advanced_Output_Bus_Line As Integer, ByVal Invert As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetRelayName", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetRelayName (ByVal Instrument_Handle As System.IntPtr, ByVal Index As Integer, ByVal Relay_Name_Buffer_Size As Integer, ByVal Relay_Name_Buffer As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetRelayCount", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetRelayCount (ByVal Instrument_Handle As System.IntPtr, ByVal Relay_Name As String, ByRef Relay_Count As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetRelayPosition", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetRelayPosition (ByVal Instrument_Handle As System.IntPtr, ByVal Relay_Name As String, ByRef Relay_Position As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_RelayControl", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RelayControl (ByVal Instrument_Handle As System.IntPtr, ByVal Relay_Name As String, ByVal Relay_Action As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_Commit", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Commit (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetChannelName", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetChannelName (ByVal Instrument_Handle As System.IntPtr, ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_Name_Buffer As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_reset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function reset (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_ResetWithDefaults", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetWithDefaults (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_Disable", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Disable (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_self_test", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function self_test (ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_revision_query", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function revision_query (ByVal Instrument_Handle As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_error_query", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function error_query (ByVal Instrument_Handle As System.IntPtr, ByRef Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetNextCoercionRecord", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetNextCoercionRecord (ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetNextInterchangeWarning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetNextInterchangeWarning (ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_ClearInterchangeWarnings", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearInterchangeWarnings (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_ResetInterchangeCheck", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetInterchangeCheck (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_close", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function close (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_error_message", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function error_message (ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViInt32 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViReal64 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Double) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViString (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Array_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViBoolean (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViSession (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViInt32 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViReal64 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViString (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViBoolean (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.UInt16) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViSession (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
End Function

        <DllImport ("niSwitch_32.dll", EntryPoint:="niSwitch_GetError", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetError (ByVal Instrument_Handle As System.IntPtr, ByRef Code As Integer, ByVal BufferSize As Integer, ByVal Description As System.Text.StringBuilder) As Integer
End Function

        Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
            If (status < 0) Then
                PInvoke.ThrowError(handle, status)
            End If
            Return status
        End Function
        
        Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
            Dim status As Integer
            Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
            Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
            If (size >= 0) Then
                msg.Capacity = size
                PInvoke.GetError(handle, status, size, msg)
            End If
            Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
        End Function
    End Class
End Class

Public Class niSwitchConstants
    
    Public Const Topology25032Wire4x6Matrix As String = "2503/2-Wire 4x6 Matrix"
    
    Public Const SwitchInitiated As Short = 1
    
    Public Const Topology25292Wire8x16Matrix As String = "2529/2-Wire 8x16 Matrix"
    
    Public Const Topology1191Quad4x1Mux As String = "1191/Quad 4x1 Mux"
    
    Public Const Topology25321WireSixteen2x16Matrix As String = "2532/1-Wire Sixteen 2x16 Matrix"
    
    Public Const Topology1167Independent As String = "1167/Independent"
    
    Public Const Topology11292WireDual8x16Matrix As String = "1129/2-Wire Dual 8x16 Matrix"
    
    Public Const Topology25032WireQuad6x1Mux As String = "2503/2-Wire Quad 6x1 Mux"
    
    Public Const Topology11301Wire8x32Matrix As String = "1130/1-Wire 8x32 Matrix"
    
    Public Const Topology11618Spdt As String = "1161/8-SPDT"
    
    Public Const Topology25014Wire12x1Mux As String = "2501/4-Wire 12x1 Mux"
    
    Public Const Topology25301Wire128x1Mux As String = "2530/1-Wire 128x1 Mux"
    
    Public Const Topology119332x1Mux As String = "1193/32x1 Mux"
    
    Public Const External As Integer = 2
    
    Public Const Topology25012Wire24x1Mux As String = "2501/2-Wire 24x1 Mux"
    
    Public Const Topology25292Wire4x32Matrix As String = "2529/2-Wire 4x32 Matrix"
    
    Public Const Topology11292Wire16x16Matrix As String = "1129/2-Wire 16x16 Matrix"
    
    Public Const Topology256831Spst As String = "2568/31-SPST"
    
    Public Const Ttl0 As Integer = 111
    
    Public Const Ttl1 As Integer = 112
    
    Public Const Topology11282Wire32x1Mux As String = "1128/2-Wire 32x1 Mux"
    
    Public Const Ttl3 As Integer = 114
    
    Public Const Ttl4 As Integer = 115
    
    Public Const Topology11284Wire16x1Mux As String = "1128/4-Wire 16x1 Mux"
    
    Public Const Ttl6 As Integer = 117
    
    Public Const Ttl7 As Integer = 118
    
    Public Const Topology25938x1TerminatedMux As String = "2593/8x1 Terminated Mux"
    
    Public Const CloseRelay As Integer = 21
    
    Public Const Frontconnector As Integer = 1001
    
    Public Const Topology2593Dual8x1Mux As String = "2593/Dual 8x1 Mux"
    
    Public Const OpenRelay As Integer = 20
    
    Public Const RearconnectorModule8 As Integer = 1028
    
    Public Const PxiStar As Integer = 125
    
    Public Const Topology11282Wire4x8Matrix As String = "1128/2-Wire 4x8 Matrix"
    
    Public Const Topology25904x1Mux As String = "2590/4x1 Mux"
    
    Public Const Topology11272Wire32x1Mux As String = "1127/2-Wire 32x1 Mux"
    
    Public Const RearconnectorModule3 As Integer = 1023
    
    Public Const RearconnectorModule1 As Integer = 1021
    
    Public Const Ttl2 As Integer = 113
    
    Public Const Topology11292Wire4x64Matrix As String = "1129/2-Wire 4x64 Matrix"
    
    Public Const Topology25301Wire8x16Matrix As String = "2530/1-Wire 8x16 Matrix"
    
    Public Const Ttl5 As Integer = 116
    
    Public Const Topology1127Independent As String = "1127/Independent"
    
    Public Const Topology2593Independent As String = "2593/Independent"
    
    Public Const Topology2567Independent As String = "2567/Independent"
    
    Public Const Topology25032Wire24x1Mux As String = "2503/2-Wire 24x1 Mux"
    
    Public Const FrontconnectorModule3 As Integer = 1043
    
    Public Const FrontconnectorModule2 As Integer = 1042
    
    Public Const FrontconnectorModule1 As Integer = 1041
    
    Public Const Topology1130Independent As String = "1130/Independent"
    
    Public Const FrontconnectorModule7 As Integer = 1047
    
    Public Const FrontconnectorModule6 As Integer = 1046
    
    Public Const Topology25031Wire48x1Mux As String = "2503/1-Wire 48x1 Mux"
    
    Public Const Topology25301Wire4x32Matrix As String = "2530/1-Wire 4x32 Matrix"
    
    Public Const Topology25032WireDual12x1Mux As String = "2503/2-Wire Dual 12x1 Mux"
    
    Public Const FrontconnectorModule9 As Integer = 1049
    
    Public Const FrontconnectorModule5 As Integer = 1045
    
    Public Const Topology1169100Spst As String = "1169/100-SPST"
    
    Public Const FrontconnectorModule8 As Integer = 1048
    
    Public Const Topology1193Independent As String = "1193/Independent"
    
    Public Const Topology11292Wire8x32Matrix As String = "1129/2-Wire 8x32 Matrix"
    
    Public Const Topology1193Dual8x1TerminatedMux As String = "1193/Dual 8x1 Terminated Mux"
    
    Public Const Topology25012Wire4x6Matrix As String = "2501/2-Wire 4x6 Matrix"
    
    Public Const Topology25321Wire4x128Matrix As String = "2532/1-Wire 4x128 Matrix"
    
    Public Const Topology11292WireQuad4x16Matrix As String = "1129/2-Wire Quad 4x16 Matrix"
    
    Public Const FrontconnectorModule4 As Integer = 1044
    
    Public Const Topology25012WireQuad6x1Mux As String = "2501/2-Wire Quad 6x1 Mux"
    
    Public Const RearconnectorModule6 As Integer = 1026
    
    Public Const Topology11301Wire256x1Mux As String = "1130/1-Wire 256x1 Mux"
    
    Public Const Topology116016Spdt As String = "1160/16-SPDT"
    
    Public Const Topology1163rOctal4x1Mux As String = "1163R/Octal 4x1 Mux"
    
    Public Const Topology11274Wire16x1Mux As String = "1127/4-Wire 16x1 Mux"
    
    Public Const Topology25292WireDual4x16Matrix As String = "2529/2-Wire Dual 4x16 Matrix"
    
    Public Const Topology259316x1Mux As String = "2593/16x1 Mux"
    
    Public Const Topology25321Wire8x64Matrix As String = "2532/1-Wire 8x64 Matrix"
    
    Public Const Topology256516Spst As String = "2565/16-SPST"
    
    Public Const Topology11271Wire64x1Mux As String = "1127/1-Wire 64x1 Mux"
    
    Public Const Topology11281Wire64x1Mux As String = "1128/1-Wire 64x1 Mux"
    
    Public Const Topology1193Quad8x1Mux As String = "1193/Quad 8x1 Mux"
    
    Public Const Topology25012Wire24x1AmplifiedMux As String = "2501/2-Wire 24x1 Amplified Mux"
    
    Public Const Topology25302Wire4x16Matrix As String = "2530/2-Wire 4x16 Matrix"
    
    Public Const Topology11302Wire4x32Matrix As String = "1130/2-Wire 4x32 Matrix"
    
    Public Const Topology119316x1TerminatedMux As String = "1193/16x1 Terminated Mux"
    
    Public Const Topology11302Wire128x1Mux As String = "1130/2-Wire 128x1 Mux"
    
    Public Const Topology25304Wire32x1Mux As String = "2530/4-Wire 32x1 Mux"
    
    Public Const Topology11928Spdt As String = "1192/8-SPDT"
    
    Public Const Topology257040Spdt As String = "2570/40-SPDT"
    
    Public Const Topology11304Wire64x1Mux As String = "1130/4-Wire 64x1 Mux"
    
    Public Const Topology11272Wire4x8Matrix As String = "1127/2-Wire 4x8 Matrix"
    
    Public Const Topology25034Wire12x1Mux As String = "2503/4-Wire 12x1 Mux"
    
    Public Const Topology1128Independent As String = "1128/Independent"
    
    Public Const Topology116632Spdt As String = "1166/32-SPDT"
    
    Public Const Topology1193Quad4x1TerminatedMux As String = "1193/Quad 4x1 Terminated Mux"
    
    Public Const Topology2593Dual4x1TerminatedMux As String = "2593/Dual 4x1 Terminated Mux"
    
    Public Const RearconnectorModule7 As Integer = 1027
    
    Public Const RearconnectorModule4 As Integer = 1024
    
    Public Const RearconnectorModule5 As Integer = 1025
    
    Public Const RearconnectorModule2 As Integer = 1022
    
    Public Const SoftwareTrig As Integer = 3
    
    Public Const Topology2530Independent As String = "2530/Independent"
    
    Public Const Topology11301Wire4x64Matrix As String = "1130/1-Wire 4x64 Matrix"
    
    Public Const Topology25914x1Mux As String = "2591/4x1 Mux"
    
    Public Const Topology25302Wire64x1Mux As String = "2530/2-Wire 64x1 Mux"
    
    Public Const MeasurementDeviceInitiated As Short = 0
    
    Public Const RearconnectorModule9 As Integer = 1029
    
    Public Const Rearconnector As Integer = 1000
    
    Public Const Topology11292WireDual4x32Matrix As String = "1129/2-Wire Dual 4x32 Matrix"
    
    Public Const Topology1193Dual16x1Mux As String = "1193/Dual 16x1 Mux"
    
    Public Const Topology25011Wire48x1Mux As String = "2501/1-Wire 48x1 Mux"
    
    Public Const BreakAfterMake As Integer = 2
    
    Public Const BreakBeforeMake As Integer = 1
    
    Public Const Topology25011Wire48x1AmplifiedMux As String = "2501/1-Wire 48x1 Amplified Mux"
    
    Public Const Topology1190Quad4x1Mux As String = "1190/Quad 4x1 Mux"
    
    Public Const Topology256616Spdt As String = "2566/16-SPDT"
    
    Public Const Topology2569100Spst As String = "2569/100-SPST"
    
    Public Const Topology25012WireDual12x1Mux As String = "2501/2-Wire Dual 12x1 Mux"
    
    Public Const None As Integer = 0
    
    Public Const FrontconnectorModule12 As Integer = 1052
    
    Public Const FrontconnectorModule10 As Integer = 1050
    
    Public Const FrontconnectorModule11 As Integer = 1051
    
    Public Const Immediate As Integer = 1
    
    Public Const RearconnectorModule12 As Integer = 1032
    
    Public Const RearconnectorModule11 As Integer = 1031
    
    Public Const RearconnectorModule10 As Integer = 1030
End Class

Public Enum niSwitchProperties
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    RangeCheck = 1050002
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    QueryInstrumentStatus = 1050003
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    Cache = 1050004
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    Simulate = 1050005
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    RecordCoercions = 1050006
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    InterchangeCheck = 1050021
    
    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverDescription = 1050514
    
    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverPrefix = 1050302
    
    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverVendor = 1050513
    
    '''<summary>
    '''System.String
    '''</summary>
    SpecificDriverRevision = 1050551
    
    '''<summary>
    '''System.Int32
    '''</summary>
    SpecificDriverClassSpecMajorVersion = 1050515
    
    '''<summary>
    '''System.Int32
    '''</summary>
    SpecificDriverClassSpecMinorVersion = 1050516
    
    '''<summary>
    '''System.String
    '''</summary>
    SupportedInstrumentModels = 1050327
    
    '''<summary>
    '''System.String
    '''</summary>
    GroupCapabilities = 1050401
    
    '''<summary>
    '''System.Int32
    '''</summary>
    ChannelCount = 1050203
    
    '''<summary>
    '''System.String
    '''</summary>
    InstrumentManufacturer = 1050511
    
    '''<summary>
    '''System.String
    '''</summary>
    InstrumentModel = 1050512
    
    '''<summary>
    '''System.String
    '''</summary>
    InstrumentFirmwareRevision = 1050510
    
    '''<summary>
    '''System.String
    '''</summary>
    DriverSetup = 1050007
    
    '''<summary>
    '''System.String
    '''</summary>
    LogicalName = 1050305
    
    '''<summary>
    '''System.String
    '''</summary>
    IoResourceDescriptor = 1050304
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    IsSourceChannel = 1250001
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    IsConfigurationChannel = 1250003
    
    '''<summary>
    '''System.String
    '''</summary>
    SerialNumber = 1150015
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    IsDebounced = 1250002
    
    '''<summary>
    '''System.Double
    '''</summary>
    SettlingTime = 1250004
    
    '''<summary>
    '''System.Double
    '''</summary>
    Bandwidth = 1250005
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxDcVoltage = 1250006
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxAcVoltage = 1250007
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxSwitchingDcCurrent = 1250008
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxSwitchingAcCurrent = 1250009
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxCarryDcCurrent = 1250010
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxCarryAcCurrent = 1250011
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxSwitchingDcPower = 1250012
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxSwitchingAcPower = 1250013
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxCarryDcPower = 1250014
    
    '''<summary>
    '''System.Double
    '''</summary>
    MaxCarryAcPower = 1250015
    
    '''<summary>
    '''System.Double
    '''</summary>
    CharacteristicImpedance = 1250016
    
    '''<summary>
    '''System.Int32
    '''</summary>
    WireMode = 1250017
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NumberOfRelays = 1150014
    
    '''<summary>
    '''System.String
    '''</summary>
    ScanList = 1250020
    
    '''<summary>
    '''System.Int32
    '''</summary>
    ScanMode = 1250021
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    ContinuousScan = 1250026
    
    '''<summary>
    '''System.Int32
    '''</summary>
    TriggerInput = 1250022
    
    '''<summary>
    '''System.Int32
    '''</summary>
    ScanAdvancedOutput = 1250023
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    IsScanning = 1250024
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    IsWaitingForTrig = 1150004
    
    '''<summary>
    '''System.Double
    '''</summary>
    ScanDelay = 1250025
    
    '''<summary>
    '''System.Int32
    '''</summary>
    TriggerInputPolarity = 1150010
    
    '''<summary>
    '''System.Int32
    '''</summary>
    ScanAdvancedPolarity = 1150011
    
    '''<summary>
    '''System.Int32
    '''</summary>
    HandshakingInitiation = 1150013
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NumOfRows = 1250018
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NumOfColumns = 1250019
    
    '''<summary>
    '''System.Int32
    '''</summary>
    CabledModuleScanAdvancedBus = 1150009
    
    '''<summary>
    '''System.Int32
    '''</summary>
    CabledModuleTriggerBus = 1150008
    
    '''<summary>
    '''System.Int32
    '''</summary>
    MasterSlaveScanAdvancedBus = 1150007
    
    '''<summary>
    '''System.Int32
    '''</summary>
    MasterSlaveTriggerBus = 1150006
    
    '''<summary>
    '''System.String
    '''</summary>
    ParsedScanList = 1150012
    
    '''<summary>
    '''System.Int32
    '''</summary>
    TriggerMode = 1150005
    
    '''<summary>
    '''System.Int32
    '''</summary>
    SerialNumberI32 = 1150001
End Enum
End Namespace